﻿package {

	import flash.display.MovieClip;
	import flash.events.Event;
	
	import com.greensock.*;
	import flash.events.MouseEvent;
	import flash.display.SimpleButton;


	public class TimelineDemoPreview extends MovieClip {
    
	//mc instances on stage
	public var gti_mc:MovieClip;
	public var hello_mc:MovieClip;
	public var colors_mc:MovieClip;
	public var black_mc:MovieClip;
	public var cover_mc:MovieClip;
	public var progress_mc:MovieClip;
	
	//replay button added to increase usability
	public var replay_btn:SimpleButton;
	
	//color values
	public var black:Number = 0x222222;
    public var blue:Number = 0x233A5C;
	public var white:Number = 0xEDEEE9;
	public var red:Number = 0x9B1C27;
	
	// TimelineLite reference
	public var tl:TimelineLite;

		public function TimelineDemoPreview() {
			addEventListener(Event.ADDED_TO_STAGE, init);

		}

		private function init(e:Event):void {

			removeEventListener(Event.ADDED_TO_STAGE, init);
			replay_btn.addEventListener(MouseEvent.CLICK, replay);
			
			//constructor
			tl = new TimelineMax({onUpdate:updateHandler});
			
			
			//tweens that introduce car
			tl.insert( TweenMax.from (gti_mc, .5, {x:-500, blurFilter:{blurX:140}}) );
			tl.insert( TweenLite.from (gti_mc.wheel1_mc, .5, {rotation:-180}) );
			tl.insert( TweenLite.from (gti_mc.wheel2_mc, .5, {rotation:-180}) );
			
			//introduce first text and hide after 1 second
			tl.append( TweenMax.from( hello_mc, .5, {alpha:0, repeat:1, repeatDelay:1, yoyo:true}),.5);
			
			//introduce second text
			tl.append( TweenMax.from( colors_mc, .5, {alpha:0}), .5 );
			
			//tint sequence
			tl.append( TweenMax.to( gti_mc.body_mc, .2, {tint:blue}) , .5);
			tl.append( TweenMax.to( gti_mc.body_mc, .2, {tint:red}) , .5);
			tl.append( TweenMax.to( gti_mc.body_mc, .2, {tint:black}) , .5);
			
			//last text
			tl.append( TweenMax.from( black_mc, .5, {alpha:0}), 1 );
			
			//optional: inserts black box reveal at the beginning of the timeline
			tl.prepend( TweenLite.from ( cover_mc, .5, {y:0}) ); 
			
			
			trace("duration  = " + tl.duration);
			
			
		}
		//event handlers
		
		//adjust the progress bar
		private function updateHandler():void{
			progress_mc.scaleX = tl.currentProgress;
			}
			
		//added to make demo more useful when shown on actitveTuts+	
		private function replay(e:MouseEvent):void{
			tl.restart();
			}	
		
			
		


	}

}